
import { Module } from '@nestjs/common';
import { ConfigModule } from '@nestjs/config';
import { localConfig } from '../../config/local.config';
import { loggerConfig } from '../../config/logger.config';
import { databaseConfig } from '../../config/database.config';

@Module({
  imports: [
    ConfigModule.forRoot({
      isGlobal: true,
      expandVariables: true,
      load: [localConfig, loggerConfig, databaseConfig],
    }),
  ],
})
export class AppConfigModule {}
